c     Copyright (C) 2008-2009 Vincent Eymet
c
c     Planet_EMC is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     Planet_EMC is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with Planet_EMC; if not, see <http://www.gnu.org/licenses/>
c
      subroutine init(np,seeds,ninv,dim)
      implicit none
      include 'max.inc'

      integer np
      integer seed
      integer seeds(1:Nproc_mx)
      integer ninv(1:Nproc_mx)
      integer dim
      integer proc
      character*200 command

      integer strlen
      character*100 label
      label='subroutine init'

c     read seed for process 0
      call read_seed(seed)
      if (seed.le.0) then
         call generate_1seed(seed)
      endif
      call zufalli(seed)

c     generate seeds for slave processes
      do proc=1,np-1
         call generate_1seed(seeds(proc))
         ninv(proc)=0
      enddo

c     3-dimensional space
      dim=3
      if (dim.gt.Nmat_mx) then
         write(*,*) 'Error from ',label(1:strlen(label)),':'
         write(*,*) 'dim=',dim
         write(*,*) 'is greater than Nmat_mx=',Nmat_mx
         stop
      endif

c     erase previous log files
      command='rm -f ./logs/last_chance*'
      call exec(command)
      command='rm -f ./logs/error_process*'
      call exec(command)
      
      
      return
      end
