      subroutine check_space_altitudes(Nz,Ntheta,Nphi,z)
      implicit none
      include 'max.inc'
      integer strlen
      integer Nz(1:Ntheta_mx,1:Nphi_mx),Ntheta,Nphi
      double precision z(0:Nr_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision z0
      integer itheta,iphi
      character*100 label
      label='check_space_altitudes'

      z0=z(Nz(1,1),1,1)
      do itheta=1,Ntheta
         do iphi=1,Nphi
            if (z(Nz(itheta,iphi),itheta,iphi).ne.z0) then
               write(*,*) 'Error from routine ',
     &              label(1:strlen(label)),' :'
               write(*,*) 'Space altitude is not coherent for column:'
               write(*,*) 'itheta=',itheta
               write(*,*) 'iphi=',iphi
               stop
            endif
         enddo ! iphi
      enddo ! itheta

      return
      end
